# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "12"/> 
#<program4xi program = "photo4xi.py">
#<abstract4xi abstract = "photo content management"/>
#<refer4xi reference = "test_photo4xi.py"/>
#<note4xi note = "ACK4XI = trace not wanted; NACK4XI = trace wanted"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'analyze2photokb4xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import itertools
import os
import signal
import sys
import string
from time import localtime, strftime
import threading
import _thread
import _winapi
import weakref
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import time4xi
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi

from photo2a4xi import Photo2a4Xi
from photo2b4xi import Photo2b4Xi
from photo2c4xi import Photo2c4Xi
from photo2d4xi import Photo2d4Xi
from photo2e4xi import Photo2e4Xi
from photo2f4xi import Photo2f4Xi
from photo2g4xi import Photo2g4Xi
from photo2h4xi import Photo2h4Xi
from photo2i4xi import Photo2i4Xi
from photo2j4xi import Photo2j4Xi
from photo2k4xi import Photo2k4Xi
from photo2l4xi import Photo2l4Xi
from photo2m4xi import Photo2m4Xi
from photo2n4xi import Photo2n4Xi
from photo2o4xi import Photo2o4Xi
from photo2p4xi import Photo2p4Xi
from photo2q4xi import Photo2q4Xi
from photo2r4xi import Photo2r4Xi
from photo2s4xi import Photo2s4Xi
from photo2t4xi import Photo2t4Xi
from photo2u4xi import Photo2u4Xi
from photo2v4xi import Photo2v4Xi
from photo2w4xi import Photo2w4Xi
from photo2x4xi import Photo2x4Xi
from photo2y4xi import Photo2y4Xi
from photo2z4xi import Photo2z4Xi
from photo2_4xi import Photo2_4Xi

from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 

#"
# />

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global keys2alpha
global PhotoKB4Xi
PhotoKB4Xi = {
       'a': Photo2a4Xi,
       'b': Photo2b4Xi,
       'c': Photo2c4Xi,
       'd': Photo2d4Xi,
       'e': Photo2e4Xi,
       'f': Photo2f4Xi,
       'g': Photo2g4Xi,
       'h': Photo2h4Xi,
       'i': Photo2i4Xi,
       'j': Photo2j4Xi,
       'k': Photo2k4Xi,
       'l': Photo2l4Xi,
       'm': Photo2m4Xi,
       'n': Photo2n4Xi,
       'o': Photo2o4Xi,
       'p': Photo2p4Xi,
       'q': Photo2q4Xi,
       'r': Photo2r4Xi,
       's': Photo2s4Xi,
       't': Photo2t4Xi,
       'u': Photo2u4Xi,
       'v': Photo2v4Xi,
       'w': Photo2w4Xi,
       'x': Photo2x4Xi,
       'y': Photo2y4Xi,
       'z': Photo2z4Xi,
       '_': Photo2_4Xi} 
       
global PickleKB4Xi
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

      
# -------------------------------------------------------------------------------------------------
# Settings 
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
keys2alpha = PhotoKB4Xi.keys()                                    


#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # APU2Buffer4Xi; APU2CommandQueue4Xi ... finish2commandqueue4bpu; finish2commandqueue4apu ...
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'analyze2photokb4xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi, Process4Xi, Queue4Xi, photo4xi

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "photo4xi"
    method2print = "photo4xi" 
        
    # message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-photo4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi.com/sense/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi.com/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing photo4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">photo4xi sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-photo4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi.com/reason/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi.com/reason/sw4xi/python33/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for photo4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-photo4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi.com/ace/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi.com/ace/sw4xi/python33/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for photo4xi.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of photo4xi.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       



# -------------------------------------------------------------------------------------------------
#<function4xi function = "analyze2photokb4xi" usage = "
#    print photos        
#">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def analyze2photokb4xi():
    global PhotoKB4Xi
    global keys2alpha

    # -----------------------------------------------------------------------------------------
    # (Step 1/3)
    # -----------------------------------------------------------------------------------------        
    class2print  = "analyze2photokb4xi"
    method2print = "analyze2photokb4xi" 
     
    message2print = "{(Step 1a/33) started" + "; analyze2photokb4xi-started-by-analyze2photokb4xi: " + str(analyze2photokb4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #      
    
    print('analyze2photokb4xi KEYS2ALPHA: ', keys2alpha)                 # dict_keys(['_', 'a', 'c', 'b', 'e', 'd', 'g', 'f', 'i', 'h', 'k', 'j', 'm', 'l', 'o', 'n', 'q', 'p', 's', 'r', 'u', 't', 'w', 'v', 'y', 'x', 'z'])
    message2print = "{(Step 1b/33) using" + "; keys2alpha-using-by-analyze2photokb4xi: " + str(keys2alpha) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #      

    count2photos = 0
    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)
    # -----------------------------------------------------------------------------------------       
    for key2alpha in sorted(keys2alpha):                                                                                 # dict_keys(['_', 'a', 'c', 'b', 'e', 'd', 'g', 'f', 'i', 'h', 'k', 'j', 'm', 'l', 'o', 'n', 'q', 'p', 's', 'r', 'u', 't', 'w', 'v', 'y', 'x', 'z'])
    
        print('analyze2photokb4xi KEY2ALPHA: ', key2alpha)
        kb2photos = PhotoKB4Xi[key2alpha]                                                                                # Photo2a4Xi ... Photo2z4Xi, Photo2_4Xi
        keys2photos = kb2photos.keys()                                                                                   # _dummy
        for key2name in sorted(keys2photos):
            print(key2name)                                                                                              # _dummy
            message2print = "{(Step 2a/33) using" + "; keys2alpha-using-by-analyze2photokb4xi: " + str(keys2alpha) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
             
            kb2index = kb2photos[key2name]
            print('kb2index: ', kb2index)
            message2print = "{(Step 2b/33) using" + "; kb2index-using-by-analyze2photokb4xi: " + str(kb2index) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 
            
            keys2index = kb2index.keys()
            print(keys2index)                                                                                            # ' ',' ()'
            for key2index in keys2index:
                kb2images = kb2index[key2index]
                keys2images = kb2images.keys()
                for key2image in keys2images:
                    count2photos = count2photos + 1
                    print('index:', kb2images[key2image])                                                                # 2,4,6,8  001,003,007,007
                    if key2index == ' ':
                        print('file: ', str(key2name) + key2index + str(kb2images[key2image]) + '.jpg')                  #  _dummy 001.jpg ...
                    if key2index == ' ()':
                        print('file: ', str(key2name) + ' (' + str(kb2images[key2image]) + ')'+ '.jpg')                  # _dummy (2).jpg ...     
    
    # -----------------------------------------------------------------------------------------
    # (Step 3/3)
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 3a/33) analyzed" + "; count2photos-analyzed-by-analyze2photokb4xi: " + str(count2photos) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    #  
    print('analyze2photokb4xi COUNT2PHOTOS: ', count2photos)  
    
    
    
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense_photo4xi" usage = "senses photo knowledgebase">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense_photo4xi():
    '''
    sense_photo4xi senses photo knowledgebase
    '''

    global PhotoKB4Xi
    ack2debug = True
     
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------      

    
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------        
              
    return PhotoKB4Xi                                                     
    
    
#</function4xi>
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason_photo4xi" usage = "reasons photo knowledgebase">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
 
def reason_photo4xi():
    '''
    reason_photo4xi reasons photo knowledgebase
    '''

    global PhotoKB4Xi
    ack2debug = True
     
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------      

    
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------        
              
    return PhotoKB4Xi     


#</function4xi>
  
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense_photo4xi" usage = "aces photo knowledgebase">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

def sense_photo4xi():
    '''
    photo4xi aces photo knowledgebase
    '''

    global PhotoKB4Xi
    ack2debug = True
     
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------      

    
    # -----------------------------------------------------------------------------------------
    # 
    # -----------------------------------------------------------------------------------------        
              
    return PhotoKB4Xi     
    
#</function4xi>


     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():

    global t2xi
    global trace_object_count    

                       
    # ------------------------------------------------------------------------------------------------- 
    # (Step 1/33) INITIALIZE TRACE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1A/33) OF MAIN PHOTO4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
    
    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    
        
    # ---------------------------------------------------------------------------------------------    
    # (Step 2/33) ANALYZE PHOTOKB
    # ---------------------------------------------------------------------------------------------    
    print("(Step 2A/33) OF MAIN PHOTO4XI - TRYING TO ANALYZE PHOTO KNOWLEDGEBASE", time4xi())
    try:
        analyze2photokb4xi()
        print("(Step 2B/33) OF MAIN PHOTO4XI - TRYING TO ANALYZE PHOTO KNOWLEDGEBASE", time4xi())
    except:
        print("(Step 2Z/33) OF MAIN PHOTO4XI *** FAILED TO ANALYZE PHOTO KNOWLEDGEBASE", time4xi())        
    finally:
        # ---------------------------------------------------------------------------------------------    
        # (Step 3/33) ALWAYS PRINT TRACE
        # ---------------------------------------------------------------------------------------------     
        print ('(Step 3A/33) OF MAIN PHOTO4XI - PRINTING TRACE WITH T2XI', t2xi)
        # 
        print_trace4xi(t2xi)        
        print ('(Step 3B/33) OF MAIN PHOTO4XI - PRINTED TRACE WITH T2XI', t2xi)           
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
#<function4xi>
if __name__ == '__main__':
    main()        
#</function4xi>


#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_photo4xi.txt
#   sense-photo4xi, reason-photo4xi, ace-photo4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.dragonxi.com; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of photo4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

                                        